
package body Expressions.Variables is

    function Create_Variable( token : not null A_Identifier_Token ) return A_Variable is
        this : constant A_Variable := new Variable;
    begin
        this.Construct( token.Get_Location, token.Get_Name );
        return this;
    end Create_Variable;

    ----------------------------------------------------------------------------

    not overriding
    procedure Construct( this : access Variable; loc : Token_Location; name : String ) is
    begin
        Expression(this.all).Construct( loc );
        this.name := To_Unbounded_String( name );
    end Construct;

    ----------------------------------------------------------------------------

    function Evaluate( this    : access Variable;
                       context : not null A_Eval_Context ) return A_Value is
    begin
        return context.Resolve( To_String( this.name ) );
    end Evaluate;

end Expressions.Variables;
