
private package Support.OSX is

    -- Returns the path of the directory where system-wide application-specific
    -- data files can be read and written on an OS X system.
    function App_Data_Directory return String;

    -- Returns the file extension of executables on OS X without a leading dot
    -- character.
    function Executable_Extension return String;

    -- Returns the path of the application's executable file.
    function Executable_Path return String;

    -- Returns the path of the user's home directory.
    function Home_Directory return String;

    -- Opens a Finder window at the directory specified by 'path'. If 'path'
    -- is a file, the file will be selected in the window.
    procedure Reveal_Path( path : String );

    -- Returns the path of the OS X system font directory.
    function System_Font_Directory return String;

end Support.OSX;
