
with Widgets.Buttons;                   use Widgets.Buttons;

package Game_Views.Keen.Actions is

    -- This is called when the title screen button is clicked.
    procedure Action_Title_OK_Button( action : A_Button_Action );

    -- This is called when the New Game button is clicked.
    procedure Action_New_Game_Button( action : A_Button_Action );

    -- This is called when the Resume Game button is clicked. The button is
    -- disabled when the action is unavailable.
    procedure Action_Resume_Game_Button( action : A_Button_Action );

    -- This is called when the Quit Game button is clicked.
    procedure Action_Quit_Button( action : A_Button_Action );

    -- This is called when the retry level button is clicked.
    procedure Action_Retry_Yes_Button( action : A_Button_Action );

    -- This is called when the exit to map button is clicked.
    procedure Action_Retry_No_Button( action : A_Button_Action );

end Game_Views.Keen.Actions;
